package de.mpg.mpimet.yacgui.model;

import de.mpg.mpimet.yacgui.model.Model.Align;

/**
 * Copyright (c) 2013 Max-Planck-Institute for Meteorology, Hamburg.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   - Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *   - Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *   - Neither the name of Oracle or the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

public class IllegalConnectionException extends Exception {

	private static final long serialVersionUID = 5789085745413238193L;
	
	public IllegalConnectionException(Align sourceAlign, int sourceIndex, int targetIndex, String message) {
		super(createMessagePrefix(sourceAlign, sourceIndex, targetIndex) + message);
	}

	public IllegalConnectionException(Align sourceAlign, int sourceIndex, int targetIndex, String message, Throwable throwable) {
		super(createMessagePrefix(sourceAlign, sourceIndex, targetIndex) + message, throwable);
	}

	private static String createMessagePrefix(Align sourceAlign, int sourceIndex, int targetIndex) {
		String messagePrefix = "Connection " + sourceAlign.toString() + ":" + sourceIndex 
				+ "->" + sourceAlign.getOpposite().toString() + ":" + targetIndex + " : ";
		return messagePrefix;
	}
}
